<?php

namespace Drupal\uvf_migrate\Plugin\migrate\source;

use Drupal\migrate\Row;
use Drupal\migrate\Plugin\migrate\source\SqlBase;

/**
 * Drupal 9 user source from database.
 *
 * @MigrateSource(
 *   id = "users",
 *   source_module = "user"
 * )
 */
class Users extends SqlBase
{
    /**
     * {@inheritdoc}
     */
    public function query()
    {
        // return $this->select('users_field_data', 'u')
        //     ->fields('u')
        //     ->condition('u.uid', 0, '>');

        $query = $this->select('users_field_data', 'u');
        $query->fields('u', ['uid','name','pass','mail','created','status',]);
        $query->condition('u.uid', 0, '>');
        return $query;
    }

    /**
     * {@inheritdoc}
     */
    public function fields()
    {
        $fields = $this->baseFields();
        $fields['field_first_name'] = $this->t('First Name');
        $fields['field_last_name'] = $this->t('First Name');
        $fields['field_job_role'] = $this->t('First Name');
        $fields['field_mailing_address'] = $this->t('First Name');
        return $fields;
    }

    /**
     * {@inheritdoc}
     */
    public function prepareRow(Row $row)
    {
        // $roles = $this->select('users_roles', 'ur')
        //     ->fields('ur', ['rid'])
        //     ->condition('ur.uid', $row->getSourceProperty('uid'))
        //     ->execute()
        //     ->fetchCol();
        // $row->setSourceProperty('roles', $roles);

        // $row->setSourceProperty(
        //     'data',
        //     unserialize($row->getSourceProperty('data'))
        // );

        $uid = $row->getSourceProperty('uid');
        $row->setSourceProperty('uid', $uid);
        
        return parent::prepareRow($row);
    }

    /**
     * {@inheritdoc}
     */
    public function getIds()
    {
        return [
            'uid' => [
                'type' => 'integer',
                'alias' => 'u',
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    protected function baseFields()
    {
        $fields = array(
            'uid' => $this->t('User ID'),
            'name' => $this->t('Username'),
            'pass' => $this->t('Password'),
            'mail' => $this->t('Email'),
            'created' => $this->t('Created On'),
            'status' => $this->t('Status')
        );
        return $fields;
    }
}
